' Lisanka (SheFoxEtte) - Picture-Viewer with Zoom and Scroll, No Scaling; r.1 (343 lines, 2024-Mar-08) written by Kaze (sanmayce@sanmayce.com), the magnificent magnifier 'MagScope' is written by OldMoses.
' Lisanka (SheFoxEtte) DIZ (description):
' - this GUI tool is 100% FREE written by QB64[PE] community;
' - portable, Linux/Windows;
' - allows scrolling and zooming (with a MagScope) a picture (usually PNG/JPG) pathfilename passed via the CLIPBOARD;
' - on Linux Drag-and-Drop a file onto Lisanka launcher, or just Ctrl+C a file from Caja, or pass it on command line;
' - adjustable ScrollStep and MagnifyFactor via keys 1..9 and Z..M respectively;
' - adjustable MagScope via MouseWheel.

_Title "Lisanka (SheFoxEtte) r.1; 'Q'-Quit; 'Z'..'M'-MagFactor; '1'..'9'-ScrollStep; Space+MouseMove=Arrows; MouseWheel-MagScopeSize"

$If WINDOWS Then
        PSPlike$ = _CWD$ ' unreliable, when starting PSP.EXE from (C:\mingw, current drive and folder) with D:\PSP.EXE and current folder on D: is D:\temp then _CWD$ instead of "D:\" is "D:\temp", why?!
        PSPreal$ = PATHpsp$
        PSPlike$ = PSPreal$
        If Right$(PSPlike$, 1) <> "\" Then PSPlike$ = PSPlike$ + "\"
        PathToEngage$ = _StartDir$
        If Right$(PathToEngage$, 1) <> "\" Then PathToEngage$ = PathToEngage$ + "\"
$Else
    PSPlike$ = _CWD$
    If Right$(PSPlike$, 1) <> "/" Then PSPlike$ = PSPlike$ + "/"
    PathToEngage$ = _StartDir$
    If Right$(PathToEngage$, 1) <> "/" Then PathToEngage$ = PathToEngage$ + "/"
$End If

'ChDir _StartDir$
'ChDir PSPlike$

' Browse filename from clipboard [
'Print _Clipboard$: End
GetFirstLineOfCLP$ = _Clipboard$
If InStr(GetFirstLineOfCLP$, Chr$(10)) Then
    GetFirstLineOfCLP$ = Left$(_Clipboard$, InStr(GetFirstLineOfCLP$, Chr$(10)) - 1)
    'Caution: Getting multilines from QB64 IDE there is one extra CR
    If Right$(GetFirstLineOfCLP$, 1) = Chr$(13) Then GetFirstLineOfCLP$ = Left$(_Clipboard$, InStr(GetFirstLineOfCLP$, Chr$(13)) - 1)
Else
End If
'For i = 1 To Len(GetFirstLineOfCLP$)
'    Print Mid$(GetFirstLineOfCLP$, i, 1);
'Next
'End

' First check whether COMMAND$ houses [path]filename, if empty then check clipboard, note that %F is to be used in Linux Launcher Cammand Line field for passing 2[+] arguments otherwise separate instances will be started.
If Command$ <> "" Then
    If _FileExists(Command$) Then
        GetFirstLineOfCLP$ = Command$ 'override the clipboard
    End If
End If

If _FileExists(GetFirstLineOfCLP$) Then
    source_handle& = _LoadImage(GetFirstLineOfCLP$, 32)
Else
    source_handle& = _LoadImage(PSPlike$ + "60dfcf94-841f-4e50-849a-163c0242efda_sharpen.webp.png", 32)
End If
ratio = 1
magsiz% = 600
magfactor% = 1
ScrlStp = 3
FramesPerSecond = 500

'80*8=640x25*16=400 *7/4 -> 7*160x7*100 1120x700
' Above mode is the minimum for 1366x768
' 640/480= 4:3

If _DesktopWidth <= 1650 Then
    MaxX = 10
ElseIf _DesktopWidth >= 1920 Then
    MaxX = 14 ' 70*14=980
ElseIf _DesktopWidth >= 2880 Then '1800
    MaxX = 25
End If

For i = 6 To MaxX
    dest_handle& = _NewImage(112 * i, 70 * i, 32) '+1 for the new line
    Do: Loop Until _ScreenExists
    _ScreenMove 13, 13
    Screen dest_handle&
    _Delay .05
Next

' MakeMask [
s% = magsiz%
cn% = _ShR(s%, 1) - 1 '                                     image center
If msk& < -1 Then _FreeImage msk& '                         remove old mask if any
msk& = _NewImage(s%, s%, 32) '                              create mask image
_Dest msk&
Color , _RGB32(255, 0, 255) '                               fill mask with purple to clear color in SUB Magnify
Cls
FCirc cn%, cn%, cn%, _RGB32(0, 0, 0) '                      apply centered black circle to clearcolor in SUB Magnify
_Dest 0 '
' MakeMask ]

If source_handle& < -1 Then
    TRG_HorizontalEndPOS = _Width(dest_handle&) - 1
    TRG_VerticalEndPOS = _Height(dest_handle&) - 1
    SRC_HorizontalEndPOS = _Width(source_handle&) - 1
    SRC_VerticalEndPOS = _Height(source_handle&) - 1
    dx1 = 0: dy1 = 0
    sx1 = 0: sy1 = 0
    FieldLineLenPNG = 6
    _PutImage (dx1, dy1)-(TRG_HorizontalEndPOS, TRG_VerticalEndPOS), source_handle&, dest_handle&, (sx1, sy1)-(sx1 + TRG_HorizontalEndPOS, sy1 + TRG_VerticalEndPOS)
    LastX = _MouseX
    LastY = _MouseY
    LastHit~&& = EpochTime~&&: Stepping = 10
    Do
        buttondown1 = 0
        buttondown2 = 0
        buttondown3 = 0
        mwheel = 0
        WaitingForAKey$ = ""
        Do While WaitingForAKey$ = "" And (buttondown1 + buttondown2 + buttondown3 + Abs(mwheel) = 0) And _KeyHit = 0
            AsIfItIsINKEY% = _MouseInput
            If AsIfItIsINKEY% Then
                buttondown1 = _MouseButton(1)
                buttondown2 = _MouseButton(2)
                buttondown3 = _MouseButton(3)
                mwheel = _MouseWheel
            End If
            If mwheel = -1 Then
                If magsiz% < 1100 Then magsiz% = magsiz% + 100
            ElseIf mwheel = 1 Then
                If magsiz% > 100 Then magsiz% = magsiz% - 100
            End If
            WaitingForAKey$ = InKey$
            'the every-loop stepper [
            Select Case EpochTime~&& - LastHit~&&
                Case Is > 2 * 60: Stepping = 0
                Case Else
            End Select
            _Limit Int(FramesPerSecond * (Stepping * .1)) + 5 'to avoid 0
            'the every-loop stepper ]

            If _KeyDown(32) = 0 Then
                If magfactor% <> 1 Then _MouseHide Else _MouseShow "DEFAULT"
                Cls
                _PutImage (dx1, dy1)-(TRG_HorizontalEndPOS, TRG_VerticalEndPOS), source_handle&, dest_handle&, (sx1, sy1)-(sx1 + TRG_HorizontalEndPOS, sy1 + TRG_VerticalEndPOS)
                '_PutImage (0, 0)-(_Width(0) - 1, _Height(0) - 1), source_handle&, 0
                If _MouseInput Then LastHit~&& = EpochTime~&&: Stepping = 10
                Do While _MouseInput: Loop
                Mouse_StartX = _MouseX: Mouse_StartY = _MouseY
                If magfactor% > 1 Then
                    Magnify magfactor%, source_handle&, magsiz%, ratio, msk&
                End If
                _Display
            End If

            If (LastX <> _MouseX Or LastY <> _MouseY) And _KeyDown(32) Then
                _MouseShow "CROSSHAIR" '"LINK" 'the hand needs to reverse the arrow-logic i.e directions have to be reversed, so use cross-hair
                LastHit~&& = EpochTime~&&: Stepping = 10
                If LastY < _MouseY Then
                    If sy1 + ScrlStp <= SRC_VerticalEndPOS - TRG_VerticalEndPOS Then sy1 = sy1 + ScrlStp
                End If
                If LastY > _MouseY Then
                    If sy1 - ScrlStp >= 0 Then sy1 = sy1 - ScrlStp
                End If
                If LastX < _MouseX Then
                    If sx1 + ScrlStp <= SRC_HorizontalEndPOS - TRG_HorizontalEndPOS Then sx1 = sx1 + ScrlStp
                End If
                If LastX > _MouseX Then
                    If sx1 - ScrlStp >= 0 Then sx1 = sx1 - ScrlStp
                End If
                Cls
                _PutImage (dx1, dy1)-(TRG_HorizontalEndPOS, TRG_VerticalEndPOS), source_handle&, dest_handle&, (sx1, sy1)-(sx1 + TRG_HorizontalEndPOS, sy1 + TRG_VerticalEndPOS)
                Locate 2, 2: Print "Use Arrows (or hold Space and Mouse); ImageDimensions: "; LTrim$(Str$(SRC_HorizontalEndPOS + 1)); " x "; LTrim$(Str$(SRC_VerticalEndPOS + 1)); "; Use 1..9 for Scroll Granularity, 3 is default; ";
                Locate 3, 2: Print "TopLeftVerPos: "; AddCommasPaddedLEN$(sy1); "; TopLeftHorPos: "; AddCommasPaddedLEN$(sx1)
                _Display
                LastX = _MouseX
                LastY = _MouseY
            End If
            _Limit Int(FramesPerSecond * (Stepping * .1)) + 5 'to avoid 0
        Loop
        kk$ = WaitingForAKey$
        If Len(kk$) = 1 Then

            LastHit~&& = EpochTime~&&: Stepping = 10
            If kk$ = "1" Then ScrlStp = 1
            If kk$ = "2" Then ScrlStp = 2
            If kk$ = "3" Then ScrlStp = 3
            If kk$ = "4" Then ScrlStp = 4
            If kk$ = "5" Then ScrlStp = 5
            If kk$ = "6" Then ScrlStp = 6
            If kk$ = "7" Then ScrlStp = 7
            If kk$ = "8" Then ScrlStp = 8
            If kk$ = "9" Then ScrlStp = 9

            If UCase$(kk$) = "Z" Then
                _MouseHide
                magfactor% = 2
            ElseIf UCase$(kk$) = "X" Then
                _MouseHide
                magfactor% = 3
            ElseIf UCase$(kk$) = "C" Then
                _MouseHide
                magfactor% = 4
            ElseIf UCase$(kk$) = "V" Then
                _MouseHide
                magfactor% = 5
            ElseIf UCase$(kk$) = "B" Then
                _MouseHide
                magfactor% = 6
            ElseIf UCase$(kk$) = "N" Then
                _MouseHide
                magfactor% = 7
            ElseIf UCase$(kk$) = "M" Then
                _MouseHide
                magfactor% = 8
            Else ' Any other (non-system) key than Z..M sets magfactor% to 1 i.e. not using
                If kk$ <> "" Then
                    magfactor% = 1
                    '_MouseShow "crosshair"
                    If kk$ <> " " Then _MouseShow "DEFAULT"
                End If
            End If

        ElseIf Len(kk$) = 2 Then
            LastHit~&& = EpochTime~&&: Stepping = 10
            If Right$(kk$, 1) = Chr$(80) Then
                If sy1 + ScrlStp <= SRC_VerticalEndPOS - TRG_VerticalEndPOS Then sy1 = sy1 + ScrlStp
            End If
            If Right$(kk$, 1) = Chr$(72) Then
                If sy1 - ScrlStp >= 0 Then sy1 = sy1 - ScrlStp
            End If
            If Right$(kk$, 1) = Chr$(77) Then
                If sx1 + ScrlStp <= SRC_HorizontalEndPOS - TRG_HorizontalEndPOS Then sx1 = sx1 + ScrlStp
            End If
            If Right$(kk$, 1) = Chr$(75) Then
                If sx1 - ScrlStp >= 0 Then sx1 = sx1 - ScrlStp
            End If
            Cls
            _PutImage (dx1, dy1)-(TRG_HorizontalEndPOS, TRG_VerticalEndPOS), source_handle&, dest_handle&, (sx1, sy1)-(sx1 + TRG_HorizontalEndPOS, sy1 + TRG_VerticalEndPOS)
            'Locate 2, 2: Print "Use Arrows (or hold Space and Mouse); ImageDimensions: "; LTrim$(Str$(SRC_HorizontalEndPOS + 1)); " x "; LTrim$(Str$(SRC_VerticalEndPOS + 1)); "; Use 1..9 for Scroll Granularity, 3 is default; ";
            'Locate 3, 2: Print "TopLeftVerPos: "; AddCommasPaddedLEN$(sy1); "; TopLeftHorPos: "; AddCommasPaddedLEN$(sx1)
            _Display
        End If
    Loop Until UCase$(kk$) = "Q"
    _FreeImage source_handle& 'handle value MUST be less than -1 or error!
Else
    'grmbl sound
End If


System

Function AddCommasPaddedLEN$ (numeral)
    Shared FieldLineLenPNG
    s$ = LTrim$(Str$(numeral))
    If Len(s$) > 3 Then
        If (Len(s$) Mod 3) Then x$ = String$(3 - (Len(s$) Mod 3), " ") + s$ Else x$ = s$
        s$ = ""
        For i = 1 To Len(x$) Step 3
            s$ = s$ + Mid$(x$, i, 3) + ","
        Next
        s$ = Left$(s$, Len(s$) - 1)
    End If
    s$ = LTrim$(s$)
    Padded$ = Right$("000,000,000,000,000", FieldLineLenPNG)
    'Padded$ = Right$("                   ", FieldLineLenPNG)
    'Padded$ = Right$("...................", FieldLineLenPNG)
    Mid$(Padded$, Len(Padded$) - Len(s$) + 1, Len(s$)) = s$
    AddCommasPaddedLEN$ = Padded$
End Function

Function EpochTime~&&
    DATEstamp$ = Date$: TIMEstamp$ = Time$
    Do While DATEstamp$ <> Date$ 'redo
        DATEstamp$ = Date$: TIMEstamp$ = Time$
    Loop
    m = Val(Left$(DATEstamp$, 2))
    d~&& = Val(Mid$(DATEstamp$, 4, 2))
    y~&& = Val(Right$(DATEstamp$, 4)) - 1970
    For i = 1 To m
        Select Case i 'Add the number of days for each previous month passed
            Case 1: d~&& = d~&& 'January doestn't have any carry over days.
            Case 2, 4, 6, 8, 9, 11: d~&& = d~&& + 31
            Case 3: d~&& = d~&& + 28
            Case 5, 7, 10, 12: d~&& = d~&& + 30
        End Select
    Next
    d~&& = d~&& + y~&& * 365
    For i = 2 To y Step 4
        If m > 2 Then d~&& = d~&& + 1 'add an extra day for leap year every 4 years, starting in 1970
    Next
    d~&& = d~&& - 1 'for year 2000
    EpochTime~&& = d~&& * 24 * 60 * 60 + Val(Left$(TIMEstamp$, 2)) * 3600 + Val(Mid$(TIMEstamp$, 4, 2)) * 60 + Val(Right$(TIMEstamp$, 2))
End Function

' OldMoses [

Sub Magnify (mf%, src&, s%, r!, msk&) 'Magnify magfactor%, source_handle&, magsiz%, ratio, msk&
    Shared dx1, dy1
    Shared sx1, sy1
    Shared TRG_HorizontalEndPOS
    Shared TRG_VerticalEndPOS
    Shared SRC_HorizontalEndPOS
    Shared SRC_VerticalEndPOS
    hs% = _ShR(s%, 1): hf% = hs% / mf% '                        radius and mag at radius
    x% = map!(_MouseX, 0, _Width(src&) * r!, 0, _Width(src&) - 1) 'map mouse position relative to image
    y% = map!(_MouseY, 0, _Height(src&) * r!, 0, _Height(src&) - 1)
    mag& = _NewImage(s%, s%, 32) '                              Create magnifier lense
    '_PutImage , src&, mag&, (x% - hf%, y% - hf%)-(x% + hf%, y% + hf%) 'portion of src& to mag&
    _PutImage , src&, mag&, ((x% - hf%) + sx1, (y% - hf%) + sy1)-((x% + hf%) + sx1, (y% + hf%) + sy1)



    _Dest mag&
    _ClearColor _RGB32(0, 0, 0), msk& '                         set clearcolor to inner circle of mask
    _PutImage , msk&, mag& '                                    overlay on magnifier
    _ClearColor _RGB32(255, 0, 255), mag& '                     clearcolor purple corners of mag& placed by mask
    _PutImage (_MouseX - hs% - 1, _MouseY - hs% - 1), mag&, 0 ' place finished magnifier to screen, mouse centered
    _FreeImage mag&
End Sub 'Magnify

Sub FCirc (CX As Integer, CY As Integer, RR As Integer, C As _Unsigned Long) 'by Steve McNeill
    Dim R As Integer, RError As Integer
    Dim X As Integer, Y As Integer
    R = Abs(RR)
    RError = -R
    X = R
    Y = 0
    If R = 0 Then PSet (CX, CY), C: Exit Sub
    Line (CX - X, CY)-(CX + X, CY), C, BF
    While X > Y
        RError = RError + Y * 2 + 1
        If RError >= 0 Then
            If X <> Y + 1 Then
                Line (CX - Y, CY - X)-(CX + Y, CY - X), C, BF
                Line (CX - Y, CY + X)-(CX + Y, CY + X), C, BF
            End If
            X = X - 1
            RError = RError - X * 2
        End If
        Y = Y + 1
        Line (CX - X, CY - Y)-(CX + X, CY - Y), C, BF
        Line (CX - X, CY + Y)-(CX + X, CY + Y), C, BF
    Wend
End Sub 'FCirc

Function map! (value!, minRange!, maxRange!, newMinRange!, newMaxRange!)
    map! = ((value! - minRange!) / (maxRange! - minRange!)) * (newMaxRange! - newMinRange!) + newMinRange!
End Function 'map!

' OldMoses ]

